﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DayPilot.Web.Mvc;
using DayPilot.Web.Mvc.Data;
using DayPilot.Web.Mvc.Enums;
using DayPilot.Web.Mvc.Events.Calendar;
using TutorialCS.Data;

namespace TutorialCS.Controllers
{
    public class CalendarController : Controller
    {
        //
        // GET: /Calendar/

        public ActionResult Backend()
        {
            return new Dpc().CallBack(this);
        }

        public class Dpc : DayPilotCalendar
        {
            protected override void OnInit(InitArgs initArgs)
            {
                Events = new EventManager().FilteredData(StartDate, StartDate.AddDays(Days)).AsEnumerable();
                UpdateWithMessage("Welcome!");
            }

            protected override void OnTimeRangeSelected(TimeRangeSelectedArgs e)
            {
                new EventManager().EventCreate(e.Start, e.End, "New event");
                UpdateWithMessage("A new event was created");
            }

            protected override void OnEventMove(EventMoveArgs e)
            {
                new EventManager().EventMove(e.Id, e.NewStart, e.NewEnd);
                UpdateWithMessage("The event was moved");
            }

            protected override void OnFinish()
            {
                // update was not requested in the event handler using Update() or UpdateWithMessage()
                // skip event reloading
                if (UpdateType == CallBackUpdateType.None)
                {
                    return;
                }

                Events = new EventManager().FilteredData(StartDate, StartDate.AddDays(Days)).AsEnumerable();

                DataStartField = "eventstart";
                DataEndField = "eventend";
                DataTextField = "name";
                DataIdField = "id";
            }
        }


    }
}
