﻿Imports DayPilot.Web.Mvc
Imports DayPilot.Web.Mvc.Events.Calendar

Namespace TutorialVB
    Public Class CalendarController
        Inherits System.Web.Mvc.Controller

        Function Backend() As ActionResult
            Return New Dpc().CallBack(Me)
        End Function

        Public Class Dpc
            Inherits DayPilotCalendar

            Protected Overrides Sub OnInit(ByVal e As DayPilot.Web.Mvc.Events.Calendar.InitArgs)
                UpdateWithMessage("Welcome!")
            End Sub

            Protected Overrides Sub OnTimeRangeSelected(ByVal e As TimeRangeSelectedArgs)
                Dim em = New EventManager()
                em.EventCreate(e.Start, e.End, "New event")
                UpdateWithMessage("A new event was created")
            End Sub

            Protected Overrides Sub OnEventMove(ByVal e As DayPilot.Web.Mvc.Events.Calendar.EventMoveArgs)
                Dim em = New EventManager()
                em.EventMove(e.Id, e.NewStart, e.NewEnd)
                UpdateWithMessage("The event was moved")
            End Sub


            Protected Overrides Sub OnFinish()
                REM update was not requested in the event handler using Update() or UpdateWithMessage()
                REM skip event reloading
                If UpdateType = Enums.CallBackUpdateType.None Then
                    Return
                End If

                Dim em = New EventManager()
                Events = em.FilteredData(StartDate, StartDate.AddDays(Days)).AsEnumerable

                DataStartField = "eventstart"
                DataEndField = "eventend"
                DataTextField = "name"
                DataIdField = "id"
            End Sub

        End Class

    End Class
End Namespace